/*********************************************************/
/*                                                       */
/*                    Sample-Source to                   */
/*                       work with                       */
/*                    Off-Screen-Bitmaps                 */
/*                                                       */
/*********************************************************/
/* sb */
/* 28.04.93 */

/* includes */
#include <stddef.h>
#ifdef __GNUC__
#include <gemx.h>
#include <stdint.h>
#include <mint/osbind.h>
#ifndef _WORD
#define _WORD short
#endif
#else
#include <tos.h>
#include <vdi.h>
#include <aes.h>
#endif

/* global variables */
static _WORD screen_handle;
static _WORD b_handle;
static _WORD screen_out[128];
static _WORD bitmap_out[128];
static MFDB bitmap;
static MFDB screen;


/* open virtual workstation */
static _WORD open_vwk(_WORD *work_out)
{
	_WORD count;
	_WORD dummy;
	_WORD handle;
	_WORD work_in[11];

	handle = graf_handle(&dummy, &dummy, &dummy, &dummy);

	for (count = 0; count < 10; count++)
		work_in[count] = 1;
	work_in[10] = 2;					/* raster coordinates */

	v_opnvwk(work_in, &handle, work_out);

	return handle;
}


/* open off-screen-bitmap */
static _WORD open_bitmap(_WORD x, _WORD y, MFDB *bitmap, _WORD *work_out)
{
	_WORD count;
	_WORD dummy;
	_WORD handle;
	_WORD work_in[20];

	handle = graf_handle(&dummy, &dummy, &dummy, &dummy);

	for (count = 0; count < 10; count++)
		work_in[count] = 1;

	work_in[10] = 2;					/* raster coordinates */
	work_in[11] = x;					/* width - 1 */
	work_in[12] = y;					/* height - 1 */
	work_in[13] = work_in[14] = 0;		/* use pixelwidth and -height of screen */

	for (count = 15; count < 20; count++)
		work_in[count] = 0;				/* reserved */

	v_opnbm(work_in, bitmap, &handle, work_out);

	return handle;
}


/* set clipping for screen */
static void clip_screen(void)
{
	_WORD xyarr[4];

	xyarr[0] = 0;
	xyarr[1] = 0;
	xyarr[2] = screen_out[0];
	xyarr[3] = screen_out[1];
	vs_clip(screen_handle, 1, xyarr);
}


/* set clipping for bitmap */
static void clip_bitmap(void)
{
	_WORD xyarr[4];

	xyarr[0] = 0;
	xyarr[1] = 0;
	xyarr[2] = bitmap_out[0];
	xyarr[3] = bitmap_out[1];
	vs_clip(b_handle, 1, xyarr);
}


/* draw on the off-screen-bitmap */
static void draw(void)
{
	char bezarr[512];
	_WORD xyarr[512];
	_WORD extent[4];
	_WORD actual;
	_WORD totpts;
	_WORD totmoves;

#ifdef MONOCHROME
	vsf_color(b_handle, G_BLACK);
#else
	vsf_color(b_handle, G_GREEN);
#endif
	vsf_interior(b_handle, FIS_PATTERN);
	vsf_style(b_handle, 1);
	vsf_perimeter(b_handle, 1);
	vswr_mode(b_handle, MD_REPLACE);

	xyarr[0] = 0;
	xyarr[1] = 0;
	xyarr[2] = 250;
	xyarr[3] = 250;
	v_bar(b_handle, xyarr);

	vsf_color(b_handle, G_BLACK);
	vsf_style(b_handle, 3);
	v_bez_on(b_handle);
	v_bez_qual(b_handle, 100, &actual);

	xyarr[0] = 100;
	xyarr[1] = 100;
	xyarr[2] = 400;
	xyarr[3] = 100;
	xyarr[4] = 400;
	xyarr[5] = 400;
	xyarr[6] = 100;
	xyarr[7] = 400;

	xyarr[8] = 200;
	xyarr[9] = 200;
	xyarr[10] = 300;
	xyarr[11] = 200;
	xyarr[12] = 300;
	xyarr[13] = 300;
	xyarr[14] = 200;
	xyarr[15] = 300;

	bezarr[0] = 1;
	bezarr[1] = 0;
	bezarr[2] = 0;
	bezarr[3] = 0;
	bezarr[4] = 3;
	bezarr[5] = 0;
	bezarr[6] = 0;
	bezarr[7] = 0;

	v_bez_fill(b_handle, 8, xyarr, bezarr, extent, &totpts, &totmoves);
	v_bez_off(b_handle);

#ifdef MONOCHROME
	v_gtext(b_handle, 50, 50, "monochromer Text!");
#else
	v_gtext(b_handle, 50, 50, "Text!");
#endif
}


int main(void)
{
	_WORD xyarr[8];
#ifdef MONOCHROME
	_WORD fgbg[2];
#endif
	GRECT size;

	appl_init();				/* initialise AES */

	wind_update(BEG_UPDATE);			/* lock screen */
	wind_update(BEG_MCTRL); 			/* get keyboard and mouse control */

	if ((screen_handle = open_vwk(screen_out)) != 0)
	{
		size.g_x = 0;
		size.g_x = 0;
		size.g_w = screen_out[0] + 1;
		size.g_h = screen_out[1] + 1;
		form_dial_grect(FMD_START, &size, &size);

		bitmap.fd_addr = 0;				/* let VDI allocate bitmap */
#ifdef MONOCHROME
		bitmap.fd_nplanes = 1;			/* monochrome bitmap */
#else
		bitmap.fd_nplanes = 0;			/* planes same as screen */
#endif
		if ((b_handle = open_bitmap(799, 607, &bitmap, bitmap_out)) != 0)
		{
			clip_screen();				/* set clipping for screen */
			clip_bitmap();				/* set clipping for bitmap */
			draw();						/* draw on off-screen-bitmap */

			/* and now copy bitma to screen... */
			screen.fd_addr = 0;
			xyarr[0] = 0;
			xyarr[1] = 0;
			xyarr[2] = 799;
			xyarr[3] = 607;
			xyarr[4] = 100;
			xyarr[5] = 100;
			xyarr[6] = 899;
			xyarr[7] = 707;
#ifdef MONOCHROME
			fgbg[0] = 6;
			fgbg[1] = 2;
			if (screen_out[13] == 2)	/* only 2 colors? */
			{
				fgbg[0] = 0;			/* invert output */
				fgbg[1] = 1;
			}
			vrt_cpyfm(screen_handle, MD_REPLACE, xyarr, &bitmap, &screen, fgbg);
#else
			vro_cpyfm(screen_handle, S_ONLY, xyarr, &bitmap, &screen);
#endif

			/* print message and wait for keypress */
			v_gtext(screen_handle, 0, 32, "Press any key.");
			evnt_keybd();

			v_clsbm(b_handle);			/* close bitmap */
		} else
		{
			form_alert(1, "[1][Cannot allocate bitmap][ Cancel ]");
		}

		form_dial_grect(FMD_FINISH, &size, &size);	/* let AES redraw screen */
		v_clsvwk(screen_handle);				/* close virtual workstation */
	} else
	{
		form_alert(1, "[1][Cannot open screen][ Cancel ]");
	}

	appl_exit();

	return 0;
}
